<template>
  <div class="guest_page">
    <div class="bg-wrapper">
      <Background></Background>
    </div>
    <div class="guest_page_container">
      <div class="logo_container">
        <router-link :to="{name: 'Login'}" class="logo_link">
          <img :src="`${$baseUrl}/images/logo-HETA2.png`" alt="HETACHAIN" class="img">
        </router-link>
        <div class="guest_page_form">
          <div class="form-container">
            <div class="guest_page_form_header">
              <div class="title">{{ $t('auth.change_password.title') }}</div>
              <div class="sub_title">{{ $t('auth.change_password.sub_title') }}</div>
            </div>
            <div class="guest_page_form_body">
              <div class="input_group">
                <div class="input_group_prepend">
                  <i class="iconmo-email"></i>
                </div>
                <input @keyup.enter="reset"
                       v-validate="'required|email'"
                       @focus="resetError"
                       v-model="email"
                       data-vv-validate-on="none"
                       type="email"
                       :placeholder="$t('auth.placeholder.email')"
                       name="email"
                       class="form_input">
                <span class="invalid-feedback" v-if="errors.has('email')">{{ errors.first('email') }}</span>
              </div>
              <div class="form_actions">
                <button type="button" class="button-primary" @click="reset">{{ $t('auth.btn.upper_submit') }}</button>
              </div>
            </div>
          </div>
        </div>
      </div>
    </div>
    <guest-page-footer></guest-page-footer>
  </div>
</template>
<script>
  import { mapState } from 'vuex';
  import rf from '../../../common/requests/RequestFactory';
  import CheckAuthMixin from './CheckAuthMixin';
  import GuestPageFooter from '../../components/GuestPageFooter.vue';
  import Background from '../../components/Dashboard/Background';

  export default {
    components: {
      GuestPageFooter,
      Background
    },
    data () {
      return {
        email: '',
      };
    },
    mixins: [CheckAuthMixin],
    computed: {
      ...mapState([
        'supportedLocales',
      ]),
    },
    methods: {
      resetError () {
        this.errors.clear();
      },
      reset () {
        this.$validator.validateAll()
          .then(() => {
            if (this.errors.any()) {
              return;
            }
            const params = {
              email: this.email,
            };
            rf.getRequest('UserRequest').resetPassword(params)
              .then((res) => {
                this.$router.push('/login');
                this.$toasted.show(this.$t('auth.reset_password.send_link_message'), {
                  theme: 'bubble',
                  position: 'top-right',
                  duration: 2000
                });
              })
              .catch((error) => {
                const errors = error.errors;
                this.errors.clear();
                Object.keys(errors).forEach((key) => {
                  this.errors.add({
                    field: key,
                    msg: errors[key][0]
                  });
                });
              });
          });
      },
    },
  }
</script>

<style lang="scss" scoped>
  .guest_page_form {
    .guest_page_form_header {
      margin-top: 0px!important;
    }
  }

  .guest_page_form_header .sub_title {
    margin-top: 10px !important;
  }

  .guest_page_form_body {
    margin-top: 17px;
  }

  .form_input {
    width: 100% !important;
  }

  .logo_link {
    display: inline-block;
  }

  @media screen and (max-width: 1023px) {
    .logo_link {
      margin-bottom: 40px;
    }
    .guest_page_container {
      text-align: center;
    }
    .guest_page {
      .guest_page_form {
        display: block;
        position: static;
        transform: translateY(0);
        padding-left: 0 !important;

        .form-container {
          margin: 0 auto;
          text-align: left;
        }
      }
    }
  }
</style>
